//--------------------------------------------
// BAUD RATE CALCS 
#define FOSC 		8000000
#define BD			19200

//HI SPEED
//BRGH=1
//x=(( FOSC / baud ) / 16 ) - 1
//#define BAUDCOEFF 	((FOSC/BD)/16)-1
//LO SPEED
//BRGH=0
//x=(( FOSC / baud ) / 64 ) - 1
#define BAUDCOEFF 	((FOSC/BD)/64)-1
//------------------------------------------

/************************/
/* Function definitions */
/************************/

#define CR 13
#define SP 32
#define LF 10
#define DEL 126
#define ABORT 'A'
#define LARROW 30
#define RARROW 29

//INTERNAL FUNC DEFS
void wait_ms(int i);
void wait_us(int i);

void ControllerCMD(char val);
void ControllerDATA(char val);
void init_lcd(void);
void conv(int *pos);
void cursor(int pos);
void putcharat(int pos, int c);
void printat(int pos,char *s);
void SetCursorType(int code);
void print_top(char *s);
void print_bot(char *s);
void print_top_rom(rom char *s);
void print_bot_rom(rom char *s);
void clear_top(void);
void clear_bot(void);
void clear_screen(void);
void scroll_bot(char *s);
void fprintat(int pos,double fv,int cfield, int cplaces);
void n2printat(int pos,int nval);
void nprintat(int pos,int nval,int cfield);
void set_display_brightness(int code);

void ShowMeter(char cLevel);
void SetupCGRam(void);
char BusyCheck(void);

int streq(auto char *p, auto char *q);
//void strcpy(auto char *p, const char *q);
void trx(int c);
void keyscan(void);
void inkey(void);
void inkeyat(int pos);
void innumtextat(int pos, int l, char *buf);
void ninputat(int pos);
void finputat(int pos);
void finputfast(void);
void copy(char *b, const char *s);
void ncopy(char *b, int n);
void numat(char *s, int val, int max, int min, int pos);
int updown(int min,int max,int ival);

void sendx(char *s);
void send(char *s);
void send_coord(void);
void send_pos(void);
void send_dir(int code);

//void convert (double fval, char *buf);
//void fp(unsigned char cfield, unsigned char cplaces);
//void fp(int cfield, int cplaces);

void SetFont(char f);
void DisplayLogo(unsigned char image);
void DrawBox(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, int iFill);
void ClearBox(unsigned char x1, unsigned char y1, unsigned char x2, unsigned char y2, int iFill);


//EXTERNAL VARS
extern char key,oldkey;
extern char link;
extern char buf[];
extern char sbuffer[],ebuffer[];
extern char crflag,nflag,sflag,dirx,diry,dirz,rz;
extern char jeol,tilt,busy;
extern int nval,ntemp,sin,sout,ein,eout,cmdstart,ax,delkey,system;
extern double fval,ftemp,cx,cy,cz,crr,ct,f1000,zero,smalloffset;
extern double xstore[],ystore[],rzstore[];
extern char keycount,autorate;
extern unsigned char gcField;
extern unsigned char gcPlaces;
extern int brightness;

//EXTERNAL FUNCS
//extern void fp(unsigned char cdigits, unsigned char cplaces);
//extern void convert(double fval, char *buf);
//extern void joy3addr(int ucData);
//extern int joy3data(int ucData, char mode);
//extern void write_to_bus(unsigned int uiAddress, char ucData);
//extern char read_from_bus(unsigned int uiAddress);
//extern void read_encoders(void);
//extern void calc_pos(void);

//EXTERNAL STRINGS
extern rom char STR_S1000[];
extern rom char STR_CLEARLINE[];
extern rom char STR_SPC5[];
extern rom char STR_DECIMALPOINT[];

//EXTERNAL IO LOCATIONS
extern far rom char KpdAddress;
extern far rom char KpdData;
