//MAIN.C
//Uses Noritake Itron Gfx VFD in SERIAL mode
//	2	RA0		AUDIO INPUT (DC LEVEL)
//	3	RA1		THERMISTOR INPUT (10K TO GND)
//	4	RA2		LED OUTPUT
//	5	RA3		LED OUTPUT
//	6	RA4		LED OUTPUT
//	7	RA5		LED OUTPUT
//	8	GND
//	9	RA6/OSC
//	10	RA7/OSC
//	11	RC0		/RESET TO VFD
//	12	RC1		MB HIGH = VFD BUSY (PIC INPUT)
//	13	RC2		HB HIGH = PIC BUSY (PIC OUTPUT)
//	14	RC3

//	15	RC4
//	16	RC5
//	17	RC6		TX TO VFD
//	18	RC7		RX FROM VFD
//	19	GND
//	20	+5V
//	21	RB0		LED OUTPUT
//	22	RB1		LED OUTPUT
//	23	RB2
//	24	RB3
//	25	RB4
//	26	RB5
//	27	RB6		ICD2
//	28	RB7		ICD2

#include "main.h"
#include <delays.h>
#include <adc.h>
#include <usart.h>
//----------------------------------------------------------------------
// Serial data interrupt routine

#pragma code lowVector=0x18
void atLowVector (void)
{
_asm GOTO interrupt_routine _endasm
}
#pragma code /* return to default code section */

#pragma interruptlow interrupt_routine

void interrupt_routine(void)
{
	while(DataRdyUSART())
	{
		sbuffer[sin]=ReadUSART();
		if(sin++ > SERIAL_BUFFER_SIZE) sin=0;
	}
}

//----------------------------------------------------------------------
void UpdateTemp(void)
{
	double ftemp=25.6;
	//char fan=90;
	fprintat(25,ftemp,4,2);
	//n2printat(38,fan);
}
//------------------------------------------
void SetLED(char Green1, char Red1, char Green2, char Red2)
{
	if(Green1) PORTAbits.RA2=1; else PORTAbits.RA2=0;
	if(Red1) PORTAbits.RA3=1; else PORTAbits.RA3=0;
	if(Green2) PORTAbits.RA4=1; else PORTAbits.RA4=0;
	if(Red2) PORTAbits.RA5=1; else PORTAbits.RA5=0;
}
void DoFunkyLed(void)
{
	static char ctr;
	char g1,r1,g2,r2;
	g1=0; r1=0; g2=0; r2=0;
	ctr++;
	if(ctr>15) ctr=0;
	if(ctr & 1) g1=1;	
	if(ctr & 2) r1=1;
	if(ctr & 4) g2=1;
	if(ctr & 8) r2=1;
	SetLED(g1,r1,g2,r2);
}
//------------------------------------------
void FadeDown(void)
{
	set_display_brightness(1);
	wait_ms(100);
	set_display_brightness(2);
	wait_ms(100);
	set_display_brightness(3);
	wait_ms(100);
	
}
//------------------------------------------
void FadeUp(void)
{	
	set_display_brightness(3);
	wait_ms(100);
	set_display_brightness(2);
	wait_ms(100);
	set_display_brightness(1);
	wait_ms(100);
	set_display_brightness(0);
}
//------------------------------------------
/*void DoMagic(void)
{
	unsigned char i;
	clear_screen();	
	//						   12345678901234567890
	print_top_rom((rom char *)"INCREDIBLE MAGIC #1 ");
	print_bot_rom((rom char *)"Flashing blue light!");
	wait_ms(1000);
	clear_screen();
	print_top_rom((rom char *)"Look! I can flash my");
	print_bot_rom((rom char *)"little blue light ->");
	wait_ms(500);
	for(i=0; i<5; i++)
	{
		PORTBbits.RB0=0;
		wait_ms(200);
		PORTBbits.RB0=1;
		wait_ms(200);
	}
	wait_ms(500);
	//------
	clear_screen();	
	//						   12345678901234567890
	print_top_rom((rom char *)"INCREDIBLE MAGIC #2 ");
	print_bot_rom((rom char *)"My lights are Red!  ");
	wait_ms(500);
	for(i=0; i<5; i++)
	{
		SetLED(0,1,0,1);
		wait_ms(200);
		SetLED(0,0,0,0);
		wait_ms(200);
	}
	wait_ms(500);
	//------
	clear_screen();	
	//						   12345678901234567890
	print_top_rom((rom char *)"INCREDIBLE MAGIC #3 ");
	print_bot_rom((rom char *)"My lights are Green!");
	wait_ms(500);
	for(i=0; i<5; i++)
	{
		SetLED(1,0,1,0);
		wait_ms(200);
		SetLED(0,0,0,0);
		wait_ms(200);
	}
	wait_ms(500);
	//------
	clear_screen();	
	//						   12345678901234567890
	print_top_rom((rom char *)"INCREDIBLE MAGIC #4 ");
	print_bot_rom((rom char *)"My lights are Orange");
	wait_ms(500);
	for(i=0; i<5; i++)
	{
		SetLED(1,1,1,1);
		wait_ms(200);
		SetLED(0,0,0,0);
		wait_ms(200);
	}
	wait_ms(500);
	//------
	clear_screen();	
	//						   12345678901234567890
	print_top_rom((rom char *)"INCREDIBLE MAGIC #5 ");
	print_bot_rom((rom char *)"I can be a disco!   ");
	wait_ms(500);
	for(i=0; i<3; i++)
	{
		PORTBbits.RB0=0;
		SetLED(1,1,1,1);
		print_top_rom((rom char *)"  D   I   S   C   O ");  
		print_bot_rom((rom char *)"<- O            O ->");
		wait_ms(100);
		SetLED(0,0,1,0);
		print_top_rom((rom char *)"   D  I   S   C  O  ");  
		print_bot_rom((rom char *)"<- -            G ->");
		wait_ms(100);
		SetLED(0,1,0,0);
		print_top_rom((rom char *)"    D  I  S  C  O   ");  
		print_bot_rom((rom char *)"<- R            - ->");
		wait_ms(100);
		PORTBbits.RB0=1;
		SetLED(1,0,0,1);
		print_top_rom((rom char *)"     D  I S C  O    ");  
		print_bot_rom((rom char *)"<- G            R ->");
		wait_ms(100);
		SetLED(0,0,1,1);
		print_top_rom((rom char *)"      D I S C O     ");  
		print_bot_rom((rom char *)"<- -            O ->");
		PORTBbits.RB0=0;
		wait_ms(100);
		PORTBbits.RB0=1;
		SetLED(0,1,1,0);
		print_top_rom((rom char *)"       DISCO        ");  
		print_bot_rom((rom char *)"<- R            G ->");
		wait_ms(100);
		SetLED(1,1,0,0);
		print_top_rom((rom char *)"        DSO         ");  
		print_bot_rom((rom char *)"<- O            - ->");
		wait_ms(100);
		SetLED(1,1,0,1);
		print_top_rom((rom char *)"         S          ");  
		print_bot_rom((rom char *)"<- O            R ->");
		wait_ms(100);
		SetLED(1,1,0,0);
		print_top_rom((rom char *)"        DSO         ");  
		print_bot_rom((rom char *)"<- O            - ->");
		wait_ms(100);
		SetLED(0,1,1,0);
		print_top_rom((rom char *)"       DISCO        ");  
		print_bot_rom((rom char *)"<- R            G ->");
		wait_ms(100);
		SetLED(0,0,1,1);
		print_top_rom((rom char *)"      D I S C O     ");  
		print_bot_rom((rom char *)"<- -            O ->");
		PORTBbits.RB0=0;
		wait_ms(100);
		PORTBbits.RB0=1;
		SetLED(1,0,0,1);
		print_top_rom((rom char *)"     D  I S C  O    ");  
		print_bot_rom((rom char *)"<- G            R ->");
		wait_ms(100);
		SetLED(0,1,0,0);
		print_top_rom((rom char *)"    D  I  S  C  O   ");  
		print_bot_rom((rom char *)"<- R            - ->");
		wait_ms(100);
		PORTBbits.RB0=1;
		PORTBbits.RB0=0;
		SetLED(0,0,1,0);
		print_top_rom((rom char *)"   D  I   S   C  O  ");  
		print_bot_rom((rom char *)"<- -            G ->");
		wait_ms(100);
	}
	wait_ms(1000);
	SetLED(1,0,1,0);
	clear_screen();	
	//						   12345678901234567890
	print_top_rom((rom char *)" And now for some  ");
	print_bot_rom((rom char *)" pretty pictures.. ");
	wait_ms(3000);
}	*/		

void FlashLeds(void)
{
	PORTBbits.RB0=0;
	SetLED(1,1,1,1);
	wait_ms(100);
	SetLED(0,0,1,0);
	wait_ms(100);
	SetLED(0,1,0,0);
	wait_ms(100);
	PORTBbits.RB0=1;
	SetLED(1,0,0,1);
	wait_ms(100);
	SetLED(0,0,1,1);
	PORTBbits.RB0=0;
	wait_ms(100);
	PORTBbits.RB0=1;
	SetLED(0,1,1,0);
	wait_ms(100);
	SetLED(1,1,0,0);
	wait_ms(100);
	SetLED(1,1,0,1);
	wait_ms(100);
	SetLED(1,1,0,0);
	wait_ms(100);
	SetLED(0,1,1,0);
	wait_ms(100);
	SetLED(0,0,1,1);
	PORTBbits.RB0=0;
	wait_ms(100);
	PORTBbits.RB0=1;
	SetLED(1,0,0,1);
	wait_ms(100);
	SetLED(0,1,0,0);
	wait_ms(100);
	PORTBbits.RB0=1;
	PORTBbits.RB0=0;
	SetLED(0,0,1,0);
	wait_ms(100);
	// Total = 1300mS
}
//------------------------------------------
#define P18F2410	

void main(void)
{
	unsigned char i;
	unsigned char a;
	unsigned char gfxctr;
	int aLevel;
	OSCCON=0x72;		//Internal 8MHz oscillator
	OSCTUNE=0x00;		//No PLL, standard calibation (8MHz)
	BAUDCON=0x00;
//	baudUSART(BAUD_IDLE_CLK_LOW & BAUD_8_BIT_RATE & BAUD_WAKEUP_OFF & BAUD_AUTO_OFF);
	TRISA=0x03;			//RA0 & RA1 inputs, all others outputs
	TRISB=0x00;			//All outputs
	TRISC=0x81;			//RX input, VFD BUSY input, all others output
	init_lcd();
	PORTCbits.RC2=0;	//Signal PIC is not busy
	PORTCbits.RC0=0;
	wait_ms(100);
	PORTCbits.RC0=1;
	PORTBbits.RB0=1;	//Blue LED on
	SetLED(0,0,0,0);
	//OpenADC(ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_12_TAD, ADC_CH0 & ADC_INT_OFF ,0x0d);

	ADCON0=0x00;		//ADC off
	ADCON1=0x0d;		//AN[1..0] enabled, all others digital
	ADCON2=0xaa;		//12TAD, FOSC/32 0b0010 1010
	ADCON0=0x01;		//Turn on ADC
	
	wait_ms(500);
	//SetLED(1,1,1,1);
	
	SetCursorType(1);	

	clear_screen();
	//SetFont('A');		//Mini font
	//SetFont('B');		//Normal font
	//SetFont('C');		//Large font
	
	clear_screen();
	
	//						   12345678901234567890
	set_display_brightness(0);
	wait_ms(100);
	print_bot_rom((rom char *)"FW: V2.01 09/04/2007");
	wait_ms(2000);
	FadeDown();
	//set_display_brightness(3); //off...
	print_top_rom((rom char *)"    madinventions   ");
	print_bot_rom((rom char *)"  600W digital amp  ");
	FadeUp();
	wait_ms(3000);
	FadeDown();
	DisplayLogo(0); //Eds bass rig
	FadeUp();
	
	SetLED(0,1,0,1);
	wait_ms(4000);
	FadeDown();
	clear_screen();
	while(1)
	{
		//-----------------------------------------------	
		clear_screen();
		set_display_brightness(0);
		
		//print_bot_rom((rom char *)"T : xx.x            ");
		//putcharat(22,0);	//show degrees symbol
			
		i=0;
		DrawBox(0,0,139,5,1);
		AudioPresent=250;
			
		while(AudioPresent)
		{
			Delay100TCYx(50);
			ADCON0bits.GO=1;
			while(ADCON0bits.GO);
			aLevel=ReadADC();
			//ShowMeter(i) is 0 to 140.
			//aLevel is 0 to 1024
			//Scale aLevel to fit:
			// 1024/140 = 7.3
			i=(char)(aLevel/7);
			ShowMeter(i);
			//nprintat(21,aLevel,5);
			//nprintat(21,(int)i,3);
			//nprintat(35,(int)AudioPresent,3);
			wait_ms(30);
			if(i>0)	
			{
				AudioPresent++;	
				print_bot_rom((rom char *)"Signal ");
				SetLED(1,0,1,0);
			}else
			{
				AudioPresent--;
				print_bot_rom((rom char *)"Silent ");
				SetLED(0,1,0,1);
			}
			
			if(AudioPresent>254) AudioPresent=254;
		}	
		clear_screen();
		//						   012345678901234567890
		print_top_rom((rom char *)"   Play some bass!   ");
		print_bot_rom((rom char *)"     I'm BORED...    ");
		wait_ms(3000);
		//-----------------------------------------------	
		//DoMagic();
		FadeDown();
		//----------------
		for(i=0; i<10;i++)
		{
			clear_screen();
			DisplayLogo(i);
			FadeUp();
			//DoFunkyLed();
			//wait_ms(5000);
			FlashLeds();
			FlashLeds();
			FlashLeds();
			FlashLeds();
			FlashLeds();
			FadeDown();
		}	
		
		//-----------------------------------------------	
	}
}
